Name:           clingo
Version:        4.3.0
Release:        1%{?dist}
Summary:        A bottom up grounder for logic programs

Group:          Applications/Engineering
License:        GPLv3
URL:            http://potassco.sourceforge.net
Source0:        http://downloads.sourceforge.net/potassco/%{name}-%{version}-source.tar.gz
Patch0:         %{name}-4.3.0-limits-include.patch
Patch1:         %{name}-4.3.0-unbundle-clasp.patch
Patch2:         %{name}-4.3.0-unbundle-gringo.patch

BuildRequires:  bison
BuildRequires:  clasp-devel
BuildRequires:  dos2unix
BuildRequires:  gringo-devel
BuildRequires:  re2c
BuildRequires:  scons
BuildRequires:  zsh

%package examples
Summary:        Examples for %{name}, a bottom up grounder for logic programs
Requires:       %{name} == %{version}-%{release}
BuildArch:      noarch

%description
Clingo combines both gringo and clasp into a monolithic system. This way it
offers more control over the grounding and solving process than gringo and clasp
can offer individually - e.g., incremental grounding and solving. Clingo comes
with its own version of claspD-2 and hence now supports parallel- and
disjunctive solving. 

%description examples
This package contains the examples distributed with %{name} %{version}.

%prep
%setup -qn %{name}-%{version}-source
%patch0 -p1
%patch1 -p1
%patch2 -p1

# Use system clasp
rm -rf libclasp

# Use system gringo
rm -rf libgringo

# Fix some encodings
for f in `find examples -name '*.lp'`; do
    dos2unix $f
done

# Fix some FSF addresses in sources
for f in `find libprogram_opts -name '*.cpp'` `find libprogram_opts -name '*.h'`; do
    sed -i 's/59 Temple Place, Suite 330, Boston, MA  02111-1307  USA/51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA/' $f
done

%build
scons %{?_smp_mflags} configure WITH_TBB="tbb" WITH_LUA="lua" WITH_PYTHON="python2.7" CPPPATH="/usr/include/python2.7/" CXXFLAGS="%{optflags} -std=c++11 -O3 -DDEBUG -D_DEBUG" --build-dir=debug
scons %{?_smp_mflags} %{name} --build-dir=debug

%install
install -m0755 -D build/debug/%{name} %{buildroot}%{_bindir}/%{name}

%check
scons %{?_smp_mflags} test-%{name} --build-dir=debug

%files
%doc CHANGES COPYING NOTES README
%{_bindir}/%{name}

%files examples
%doc examples

%changelog
* Wed Apr 23 2014 Scott K Logan <logans@cottsay.net> - 4.3.0-1
- Initial package
